#!/bin/python
# vim:et:ts=4

import md5, os

class AuthDB:
    def __init__(self, dir):
        self.dir = dir

    def user_dir(self, user):
        return self.dir + "/" + user.replace("/", "")

    def login(self, user, password):
        try:
            f = open(self.user_dir(user) + "/password")
        except IOError:
            return None
        if md5.new(password.lower()).hexdigest() != f.read():
            return None
        try:
            f = open(self.user_dir(user) + "/modes")
            return f.read() 
        except IOError:
            return "-v"

    def exists(self, user):
        try:
            os.listdir(self.user_dir(user))
            return 1
        except OSError:
            return 0

    def check_exists(self, user):
        if not self.exists(user):
            os.mkdir(self.user_dir(user))

    def set_password(self, user, password):
        self.check_exists(user)
        f = open(self.user_dir(user) + "/password", "w")
        f.write(md5.new(password.lower()).hexdigest())
        f.close()

    def set_modes(self, user, modes):
        self.check_exists(user)
        f = open(self.user_dir(user) + "/modes", "w")
        f.write(modes)
        f.close()

